=== added file 'cronscripts/generate-extra-overrides.py'
--- cronscripts/generate-extra-overrides.py	1970-01-01 00:00:00 +0000
+++ cronscripts/generate-extra-overrides.py	2011-12-04 15:14:23 +0000
@@ -0,0 +1,18 @@
+#!/usr/bin/python -S
+#
+# Copyright 2011 Canonical Ltd.  This software is licensed under the
+# GNU Affero General Public License version 3 (see the file LICENSE).
+
+"""Generate extra overrides using Germinate."""
+
+import _pythonpath
+
+from lp.archivepublisher.scripts.generate_extra_overrides import (
+    GenerateExtraOverrides,
+    )
+
+
+if __name__ == '__main__':
+    script = GenerateExtraOverrides(
+        "generate-extra-overrides", dbuser='generate_extra_overrides')
+    script.lock_and_run()

=== modified file 'cronscripts/publishing/cron.germinate'
--- cronscripts/publishing/cron.germinate	2011-10-27 11:36:13 +0000
+++ cronscripts/publishing/cron.germinate	2011-12-04 15:14:23 +0000
@@ -12,8 +12,12 @@
 GERMINATEROOT=$ARCHIVEROOT/../ubuntu-germinate
 
 LAUNCHPADROOT=${TEST_LAUNCHPADROOT:-/srv/launchpad.net/codelines/current}
+GENERATE_EXTRA_OVERRIDES=$LAUNCHPADROOT/cronscripts/generate-extra-overrides.py
 MAINTAINCE_CHECK=$LAUNCHPADROOT/cronscripts/publishing/maintenance-check.py
 
+FLAVOURS="ubuntu kubuntu kubuntu-mobile edubuntu xubuntu mythbuntu lubuntu"
+FLAVOURS="$FLAVOURS ubuntustudio"
+
 ## Check to see if another germinate run is in progress
 
 LOCKFILE=$LOCKROOT/cron.germinate.lock
@@ -28,134 +32,9 @@
 
 trap cleanup EXIT
 
-suite=`$LAUNCHPADROOT/scripts/ftpmaster-tools/lp-query-distro.py development`
-archs=`$LAUNCHPADROOT/scripts/ftpmaster-tools/lp-query-distro.py -s "$suite" archs`
-
-echo -n "Running germinate... "
 cd $GERMINATEROOT
 
-# Clean up temporary files
-rm -f \
-    germinate.output ALL ALL.sources \
-    UBUNTU-* KUBUNTU-* EDUBUNTU-* XUBUNTU-* MYTHBUNTU-* LUBUNTU-* \
-    UBUNTUSTUDIO-*
-rm -f all_* all.sources_*
-rm -rf dists
-
-# Grab local copies of Sources and Packages files, to avoid problems in case
-# the archive changes under our feet.
-for component in main universe restricted multiverse; do
-  base="dists/$suite/$component"
-  mkdir -p "$base/source"
-  zcat "$ARCHIVEROOT/$base/source/Sources.gz" > "$base/source/Sources"
-  for arch in $archs; do
-    mkdir -p "$base/binary-$arch" "$base/debian-installer/binary-$arch"
-    zcat "$ARCHIVEROOT/$base/binary-$arch/Packages.gz" \
-      > "$base/binary-$arch/Packages"
-    zcat "$ARCHIVEROOT/$base/debian-installer/binary-$arch/Packages.gz" \
-      > "$base/debian-installer/binary-$arch/Packages"
-  done
-done
-
-> "$MISCROOT/more-extra.override.$suite.main.new"
-
-germinate_components=main,universe,restricted,multiverse
-for distro in \
-    ubuntu kubuntu kubuntu-mobile edubuntu xubuntu mythbuntu lubuntu \
-    ubuntustudio
-do
-  DISTRO="$(echo $distro | tr a-z A-Z)"
-  germinate_suite="$distro.$suite"
-  for arch in $archs; do
-    # Run germinate
-    echo " **************** $distro/$suite/$arch ********************* " >> germinate.output
-    germinate \
-        --no-rdepends \
-        -m "file://$(pwd)/" \
-        -s "$germinate_suite" \
-        -d "$suite" \
-        -c "$germinate_components" \
-        -a $arch >> germinate.output 2>&1
-
-    # The structure file is generally useful; keep per distro/suite/arch
-    # copies for convenience
-    cp structure structure_"$distro"_"$suite"_"$arch"
-
-    # Keep per distro/suite/arch copies of 'all' and 'all.sources' for
-    # anastacia.
-    cp all all_"$distro"_"$suite"_"$arch"
-    cp all.sources all.sources_"$distro"_"$suite"_"$arch"
-
-    # Keep per distro/suite/arch copies of 'minimal' and 'standard' for
-    # jessica.
-    cp minimal minimal_"$distro"_"$suite"_"$arch"
-    cp standard standard_"$distro"_"$suite"_"$arch"
-
-    # Keep amalgamated copies of 'all' and 'all.sources', just for convenience
-    cat all >> ALL; cat all.sources >> ALL.sources
-
-    # We need to fetch a number of seeds so that we can generate Task fields
-    # for them. This changes over time and differs from derivative to
-    # derivative, so it's best to just fetch them all.
-    taskseeds="$(cut -d: -f1 structure | xargs -n1 | sort -u)"
-
-    for seed in $taskseeds; do
-      cp "$seed" "$seed"_"$distro"_"$suite"_"$arch"
-    done
-    echo " ********************************************************************** " >> germinate.output
-    echo "" >> germinate.output
-    echo -n "."
-
-    ## Generate apt-ftparchive 'extra' overrides for Task: fields
-    for seed in $taskseeds; do
-      if ! grep -iq '^Task-' "$seed.seedtext"; then
-	continue
-      fi
-      # If the seed contains Task-Name header, override the normal behavior
-      if grep -iq '^Task-Name:' "$seed.seedtext"; then
-	task=$(grep '^Task-Name:' "$seed.seedtext" | cut -d: -f2)
-      elif grep -iq '^Task-Per-Derivative:' "$seed.seedtext"; then
-	task="$distro-$seed"
-      else
-	# If a seed is not per-derivative, then we only honour it for Ubuntu,
-	# and its task name is archive-global.
-	if [ "$distro" = ubuntu ]; then
-	  task="$seed"
-	else
-	  continue
-	fi
-      fi
-      if grep -iq '^Task-Seeds:' "$seed.seedtext"; then
-          scanseeds="$( (grep '^Task-Seeds:' "$seed.seedtext" | cut -d: -f2 | xargs -n1; echo "$seed") | sort -u )"
-      else
-	scanseeds="$seed"
-      fi
-      for scanseed in $scanseeds; do
-          egrep -v -- \
-              "^(-|Package| )" "$scanseed"_"$distro"_"$suite"_"$arch" |
-          awk '{print $1}' |
-          sed -e "s,$,/$arch  Task  $task," |
-          sort -u >> "$MISCROOT/more-extra.override.$suite.main.new"
-      done
-    done
-
-    # Generate apt-ftparchive 'extra' overrides for Build-Essential: fields
-    if [ -e build-essential ] && [ "$distro" = ubuntu ]; then
-        # Keep a copy, just for convenience
-        cp build-essential build-essential_"$distro"_"$suite"_"$arch"
-        egrep -v -- \
-            "^(-|Package| )" build-essential_"$distro"_"$suite"_"$arch" |
-        awk '{print $1}' |
-        sed -e "s,$,/$arch  Build-Essential  yes," |
-        sort -u >> "$MISCROOT/more-extra.override.$suite.main.new"
-    fi
-  done
-done
-echo " done."
-
-mv -f \
-    "$MISCROOT/more-extra.override.$suite.main.new" \
-    "$MISCROOT/more-extra.override.$suite.main"
+$GENERATE_EXTRA_OVERRIDES $FLAVOURS
 
 # Now generate the Supported extra overrides for all supported distros.
 SUITES=`$LAUNCHPADROOT/scripts/ftpmaster-tools/lp-query-distro.py supported`

=== modified file 'database/schema/security.cfg'
--- database/schema/security.cfg	2011-12-03 22:27:34 +0000
+++ database/schema/security.cfg	2011-12-04 15:14:23 +0000
@@ -2264,6 +2264,10 @@
 type=user
 groups=archivepublisher
 
+[generate_extra_overrides]
+type=user
+groups=archivepublisher
+
 [process_death_row]
 type=user
 groups=archivepublisher

=== added file 'lib/lp/archivepublisher/scripts/generate_extra_overrides.py'
--- lib/lp/archivepublisher/scripts/generate_extra_overrides.py	1970-01-01 00:00:00 +0000
+++ lib/lp/archivepublisher/scripts/generate_extra_overrides.py	2011-12-04 15:14:23 +0000
@@ -0,0 +1,226 @@
+# Copyright 2011 Canonical Ltd.  This software is licensed under the
+# GNU Affero General Public License version 3 (see the file LICENSE).
+
+"""Generate extra overrides using Germinate."""
+
+__metaclass__ = type
+__all__ = [
+    'GenerateExtraOverrides',
+    ]
+
+import os
+import logging
+
+from germinate.germinator import Germinator
+from germinate.archive import TagFile
+from germinate.log import GerminateFormatter
+from germinate.seeds import SeedStructure
+
+from zope.component import getUtility
+
+from lp.app.errors import NotFoundError
+from lp.archivepublisher.config import getPubConfig
+from lp.registry.interfaces.distribution import IDistributionSet
+from lp.registry.interfaces.series import SeriesStatus
+from lp.services.scripts.base import (
+    LaunchpadScript,
+    LaunchpadScriptFailure,
+    )
+from lp.soyuz.enums import ArchivePurpose
+
+
+class AtomicFile:
+    """Facilitate atomic writing of files."""
+
+    def __init__(self, filename):
+        self.filename = filename
+        self.fd = open('%s.new' % self.filename, 'w')
+
+    def __enter__(self):
+        return self.fd
+
+    def __exit__(self, exc_type, exc_value, exc_tb):
+        self.fd.close()
+        os.rename('%s.new' % self.filename, self.filename)
+
+
+class GenerateExtraOverrides(LaunchpadScript):
+    """Main class for scripts/ftpmaster-tools/generate-task-overrides.py."""
+
+    def __init__(self):
+        self.seeds = {}
+        self.seed_structures = {}
+
+    def add_my_options(self):
+        """Add a 'distribution' context option."""
+        self.parser.add_option(
+            '-d', '--distribution', dest='distribution_name',
+            default='ubuntu', help='Context distribution name.')
+
+    def processOptions(self):
+        try:
+            self.distribution = getUtility(
+                IDistributionSet)[self.options.distribution_name]
+        except NotFoundError, err:
+            raise LaunchpadScriptFailure(
+                "Could not find distribution %s" % err)
+
+        series = None
+        wanted_status = (SeriesStatus.DEVELOPMENT,
+                         SeriesStatus.FROZEN)
+        for status in wanted_status:
+            series = self.distribution.getSeriesByStatus(status)
+            if series.count() > 0:
+                break
+        else:
+            raise LaunchpadScriptFailure(
+                'There is no DEVELOPMENT distroseries for %s' %
+                self.options.distribution_name)
+        self.series = series[0]
+
+        self.architectures = self.series.architectures
+
+        # Even if DistroSeries.component_names starts including partner, we
+        # don't want it; this applies to the primary archive only.
+        self.components = [component
+                           for component in self.series.component_names
+                           if component != 'partner']
+
+    def getConfig(self):
+        """Set up a configuration object for this archive."""
+        for archive in self.distribution.all_distro_archives:
+            # We only work on the primary archive.
+            if archive.purpose == ArchivePurpose.PRIMARY:
+                return getPubConfig(archive)
+        else:
+            raise LaunchpadScriptFailure(
+                'There is no PRIMARY archive for %s' %
+                self.options.distribution_name)
+
+    def setUp(self):
+        """Process options, and set up internal state."""
+        self.processOptions()
+        self.config = self.getConfig()
+
+        self.germinate_logger = logging.getLogger('germinate')
+        self.germinate_logger.setLevel(logging.INFO)
+        log_file = os.path.join(self.config.germinateroot, 'germinate.output')
+        handler = logging.FileHandler(log_file, mode='w')
+        handler.setFormatter(GerminateFormatter())
+        self.germinate_logger.addHandler(handler)
+        self.germinate_logger.propagate = False
+
+    def outputPath(self, flavour, arch, base):
+        return os.path.join(
+            self.config.germinateroot,
+            '%s_%s_%s_%s' % (base, flavour, self.series.name, arch))
+
+    def runGerminate(self, override_file, arch, flavours):
+        germinator = Germinator(arch)
+
+        # Read archive metadata.
+        archive = TagFile(
+            self.series.name, self.components, arch,
+            'file:/%s' % self.config.archiveroot, cleanup=True)
+        germinator.parse_archive(archive)
+
+        for flavour in flavours:
+            self.logger.info('Germinating for %s/%s/%s',
+                             flavour, self.series.name, arch)
+            # Add this to the germinate log as well so that that can be
+            # debugged more easily.  Log a separator line first.
+            self.germinate_logger.info('', extra={'progress': True})
+            self.germinate_logger.info('Germinating for %s/%s/%s',
+                                       flavour, self.series.name, arch,
+                                       extra={'progress': True})
+
+            # Expand dependencies.
+            structure = self.seed_structures[flavour]
+            germinator.plant_seeds(structure)
+            germinator.grow(structure)
+            germinator.add_extras(structure)
+
+            # Write output files.
+
+            # The structure file makes it possible to figure out how the
+            # other output files relate to each other.
+            structure.write(self.outputPath(flavour, arch, 'structure'))
+
+            # "all" and "all.sources" list the full set of binary and source
+            # packages respectively for a given flavour/suite/architecture
+            # combination.
+            all_path = self.outputPath(flavour, arch, 'all')
+            all_sources_path = self.outputPath(flavour, arch, 'all.sources')
+            germinator.write_all_list(structure, all_path)
+            germinator.write_all_source_list(structure, all_sources_path)
+
+            # Write the dependency-expanded output for each seed.  Several
+            # of these are used by archive administration tools, and others
+            # are useful for debugging, so it's best to just write them all.
+            for seedname in structure.names:
+                germinator.write_full_list(
+                    structure, self.outputPath(flavour, arch, seedname),
+                    seedname)
+
+            def writeOverrides(seedname, key, value):
+                packages = germinator.get_full(structure, seedname)
+                for package in sorted(packages):
+                    print >>override_file, '%s/%s  %s  %s' % (
+                        package, arch, key, value)
+
+            # Generate apt-ftparchive "extra overrides" for Task fields.
+            for seedname in structure.names:
+                if seedname == 'extra':
+                    continue
+
+                task_headers = {}
+                with structure[seedname] as seedtext:
+                    for line in seedtext:
+                        if line.lower().startswith('task-') and ':' in line:
+                            key, value = line.split(':', 1)
+                            key = key[5:].lower() # e.g. "Task-Name" => "name"
+                            task_headers[key] = value.strip()
+                if not task_headers:
+                    continue
+
+                # Work out the name of the Task to be generated from this
+                # seed.  If there is a Task-Name header, it wins; otherwise,
+                # seeds with a Task-Per-Derivative header are honoured for
+                # all flavours and put in an appropriate namespace, while
+                # other seeds are only honoured for the first flavour and
+                # have archive-global names.
+                if 'name' in task_headers:
+                    task = task_headers['name']
+                elif 'per-derivative' in task_headers:
+                    task = '%s-%s' % (flavour, seedname)
+                elif flavour == flavours[0]:
+                    task = seedname
+                else:
+                    continue
+
+                # The list of packages in this task come from this seed plus
+                # any other seeds listed in a Task-Seeds header.
+                scan_seeds = set([seedname])
+                if 'seeds' in task_headers:
+                    scan_seeds.update(task_headers['seeds'].split())
+                for scan_seed in sorted(scan_seeds):
+                    writeOverrides(scan_seed, 'Task', task)
+
+            # Generate apt-ftparchive "extra overrides" for Build-Essential
+            # fields.
+            if 'build-essential' in structure.names and flavour == flavours[0]:
+                writeOverrides('build-essential', 'Build-Essential', 'yes')
+
+    def main(self):
+        self.setUp()
+
+        for flavour in self.args:
+            self.seed_structures[flavour] = SeedStructure(
+                '%s.%s' % (flavour, self.series.name))
+
+        override_path = os.path.join(
+            self.config.miscroot,
+            'more-extra.override.%s.main' % self.series.name)
+        with AtomicFile(override_path) as override_file:
+            for arch in self.architectures:
+                self.runGerminate(override_file, arch, self.args)

